
CoCoALib - Bug #264

Compilation problem with "degree.H" (inline fn defns)

12 Oct 2012 19:22 - Anna Maria Bigatti

Status: Closed Start date: 12 Oct 2012

Priority: High Due date:  

Assignee:  % Done: 100%

Category: Various Estimated time: 1.00 hour

Target version: CoCoALib-0.99534 Seoul14 Spent time: 1.05 hour

Description

I have a very strange problem compiling the debug2 version.

(indeed it is not related with debugging at all, but with a file I have only in my debug directory!)

It seems that adding

#include "CoCoA/degree.H" 

in some .C files (e.g. PPOrdering.C) causes this compilation error

../../include/CoCoA/utils.H: In function 'int CoCoA::LexCmp3(InputIterator1, InputIterator1, Input

Iterator2, InputIterator2) [with InputIterator1 = const CoCoA::BigInt*, InputIterator2 = const CoC

oA::BigInt*]':

../../include/CoCoA/degree.H:89:   instantiated from here

../../include/CoCoA/utils.H:96: error: no matching function for call to 'cmp(const CoCoA::BigInt&,

 const CoCoA::BigInt&)'

../../include/CoCoA/ring.H:327: note: candidates are: int CoCoA::cmp(CoCoA::ConstRefRingElem, CoCo

A::ConstRefRingElem)

../../include/CoCoA/ring.H:358: note:                 int CoCoA::cmp(CoCoA::ConstRefRingElem, cons

t CoCoA::MachineInt&)

Related issues:

Related to CoCoALib - Bug #591: Problem with template instantiation and order... In Progress 16 Jul 2014

History

#1 - 12 Oct 2012 19:23 - Anna Maria Bigatti

- Category set to Various

#2 - 14 Oct 2012 16:27 - John Abbott

Try adding (in the right place...)

#include "CoCoA/IntOperations.H" 

#3 - 03 Jun 2013 17:26 - John Abbott

- Subject changed from Compilation problem with "degree.H" to Compilation problem with "degree.H" (inline fn defns)

- Status changed from New to In Progress

- Target version set to CoCoALib-0.99534 Seoul14

- % Done changed from 0 to 10
Why are the ctor and the mem fn FastCmp inline?

Now that the components of the degree vector are BigInt, I doubt that making these fns inline really gains much run speed at all.

MAKE TIMING OF CODE AS IT IS

MAKE CTOR AND FASTCMP not INLINE then COMPARE TIMINGS.

If there is not much penalty, make the fns out of line.

#4 - 29 Oct 2013 14:57 - Anna Maria Bigatti

- Target version changed from CoCoALib-0.99534 Seoul14 to CoCoALib-0.99532

#5 - 01 Apr 2014 17:26 - Anna Maria Bigatti

- Target version changed from CoCoALib-0.99532 to CoCoALib-0.99533 Easter14

#6 - 07 Apr 2014 18:23 - John Abbott

- Target version changed from CoCoALib-0.99533 Easter14 to CoCoALib-0.99534 Seoul14

#7 - 20 May 2014 10:37 - John Abbott

Is this still a problem?

#8 - 09 Jul 2014 17:59 - John Abbott

@Anna Is this still a problem?  I hope not; then we can just terminate the issue.

#9 - 09 Jul 2014 18:15 - Anna Maria Bigatti

- Status changed from In Progress to Closed

- % Done changed from 10 to 100

- Estimated time set to 1.00 h

No problem has ever occurred to anyone in the last year.

Have we fixed it? can't remember.

Has the compiler changed? don't think so.

....Closing.

#10 - 16 Jul 2014 14:42 - John Abbott

This seems to be very similar to the issue #591; I believe they are occurrences of the same phenomenon.  Added #591 as "related".
